%grade_plots_total.m
% Script file to make distribution plots for the final
% grades.
%modified 3/17/03  -A. Ruina

figure(3);  clf;        % Plots of total_grade
set(3,'PaperPosition', [.25 .25 8 10])

subplot(4,1,1)
  axis('off')
  title('Distribution (histogram) plots of total grade which determines letter grade.')
  text(.2,.9,'May 17, 2003')
  text(.2,.75,'Ideally a ''bell'' curve.')
  text(.2,.5,'Plotted 3 times with different numbers of bins.')
  text(.3,.25,['median=', num2str(median(total_grade))...
          ',  max=',num2str(max(total_grade)) ])
 
%histogram plots  
subplot(4,1,2)
  hist(total_grade, 10)
  set(gca, 'AspectRatio', [ 2 NaN ])
   ylabel('# students,   10 bins')


subplot(4,1,3)
  hist(total_grade, 30)
  set(gca, 'AspectRatio', [ 2 NaN ])
  ylabel('# students   30 bins')

subplot(4,1,4)
  hist(total_grade, 60)
  set(gca, 'AspectRatio', [ 2 NaN ])
  xlabel('total grade, cumulative of all grades, after all ''drop the lowest'' schemes ')
  ylabel('# students,  60 bins')



%Cumulutive distribution plot
figure(4);clf; set(4,'PaperPosition', [.25 .25 10.5 8])
  plot(sort(total_grade),...
            (1:nstud), '.')
  title(['Class rank vs total grade.  Ideally an error function plot. Grade cuttoffs also shown.', '5/17/03'])
  ylabel( ['student rank  (1 is worst,  ', ...
            num2str(nstud),  ' is best)'])
  xlabel('total grade,  the number that totals all grade components')

  set(gca, 'AspectRatio', [ 1.25 NaN ])
  set(gca, 'Position', [ .1 .1 .8 .8 ])
  axis(axis);hold on
  for i=1:13;
   plot( [ (cutoff(i)+1) (cutoff(i)+1)],  [0  nstud]); %plots a vertical line at grade cutoff
   text(cutoff(i)+.5,50, letter(i,:))
  end;
  hold off

