%Grade calculator for TAM 202, spring 2003
%This is the sanitized version that leaves out student names

nstud=length(allgrades(:,1));
%pick out the parts from the data in allgrades
final   = allgrades(:,1);
quiz      = allgrades(:,2:15);  % 14 quiz grades
labs    = allgrades(:,16:19);   %  4 lab grades
hw      = allgrades(:,20:34);   % 15 homework grades
ceval   = allgrades(:,35);      %  1 or zero for course evaluation

% Drop the lowest two of 15 homework grades
hwt = hw';                  %transpose because sort and sum work on columns
hwts = sort(hwt);
hwtsd = sum(hwts(3:end,:)); %drop the lowest 2 homeworks
hwave = hwtsd'/(3*13);      %put homework on a  10 point scale.
% at this point hw has one number from 0-10 for each student for homework.


%merge the hwave and quiz grades,  pluck out the best 6, scale out
%of 50.
quizhw    = [quiz hwave hwave];
quizhwts  = sort(quizhw');
quizhwtsd = sum(quizhwts(end-5:end,:)); % take the best 6
quizhwave = 50*quizhwtsd'/60;           % put the total on a 50 point scale

labs = sum(labs')'/4;


%Calculate the big number called total_grade.  This number determines
%the course grade.

total_grade =   final*35/120    ...     %put on 35 point scale
              + quizhwave  ...
			  + labs         ...
			  + ceval            ;
	
%The grade cutoffs for assigning letters from the numbers above
cutoff=[  96  % A+   Cutoff is 97, push up students within a point
          91  % A    Cutoff is 92, push up students within a point
		  89  % A-   Cutoff is 90, push up students within a point
		      %
		  86  % B+   Cutoff is 87, push up students within a point
		  80  % B    Cutoff is 81, push up students within a point
		  76  % B-   Cutoff is 77, push up students within a point
		      %
		  72  % C+   Cutoff is 73, push up students within a point
		  66  % C    Cutoff is 67, push up students within a point
		  64  % C-   Cutoff is 65, push up students within a point
		      %
		  56  % D+   Cutoff is 57, push up students within a point
		  52  % D    Cutoff is 53, push up students within a point
		  38  % D-   Cutoff is 39, push up students within a point
		      %
	       0];% F

%Assign letter grades based on  cutoff 			 				

% character array of grades
letter=reshape('A+A A-B+B B-C+C C-D+D D-F ',2, 13)';

%initialize letter_grade,   two spaces for each row
%32 is the character number for blank
blanks       = setstr( 32* ones(nstud, 2)); 
letter_grade = blanks;

%Make an array of letter grades in the same order as the
%list of total_grade numbers
for j=1:nstud;    % once through for each student
  for i=13:-1:1;                %once through for each letter grade
    if ( total_grade(j)   >= cutoff(i) -.1  ); % give .05 pt slack
	     letter_grade(j,:) = letter(i,:)  ;  % assign letter grade
	end;
  end;
end;
		 
%Uncomment the line below to see a sorted list of grades.
%[num2str(total_grade) blanks letter_grade ]	
%num2str([total_grade blanks letter_grade])

%Give the grades as a sorted list
[total_sorted, i] = sort(total_grade);
letter_sorted = letter_grade(i,:);
[num2str(total_sorted) blanks letter_sorted ]			 

